structure CMLDEMO : sig

    val main  : (string * string list) -> OS.Process.status

  end = struct
  
    val countChan : int CML.chan = CML.channel () 
    val exitChan : unit CML.chan = CML.channel () 
    (* send a count on the countChan until signaled to exit. *) 
    fun produceCount n = 
        CML.select([ 
            CML.wrap(CML.sendEvt(countChan,n),
                fn () => (produceCount (n+1))), 
            CML.wrap(CML.recvEvt(exitChan), 
                fn () => (RunCML.shutdown OS.Process.success)) 
        ]) 
    (* receive a count on countChan until count is at least 100,
     * then signal the producer to exit. *) 
    fun consumeCount () = 
        let 
        val n = CML.recv(countChan) 
        val _ = TextIO.print ("Consumer received "^
                    (Int.toString n)^"\n") 
        in 
            if (n<100) 
            then consumeCount () 
            else CML.send (exitChan, ()) 
         end 
    fun main _ = RunCML.doit ((fn () => (
        CML.spawn (fn () => (produceCount 0)); 
        CML.spawn (consumeCount); ()
    )),NONE)
end